// 15Puzzle.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "15Puzzle.h"

#define MAX_LOADSTRING 100

#define MAX_COL		(4)		// J
#define MAX_ROW		(4)		// s

// AvP[Ṽf[^\
struct PuzzleData{
	int cell[MAX_COL][MAX_ROW];
};
	
// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

// 萔IɈ̂ŁCO[oϐƂĂB
// staticĐ錾Ă̂ŁC̃\[XER[h͌ȂB
static int xOrg = 5;		// xW
static int yOrg = 5;		// yW
static int cellWidth = 50;	// R}̕
static int cellHeight = 50;	// R}̍

// gpāCR}̏ԂVbt
static void ShuffleCells( PuzzleData *pPuzzleData)
{
	int maxNum = MAX_COL * MAX_ROW - 1;
	int permutation[MAX_COL*MAX_ROW-1];
	for( int i=0; i<maxNum; i++){
		permutation[i] = i + 1;
	}
	for( int i=0; i<maxNum-1; i++){
		int toIdx = i + rand() % ( maxNum - i);
		if( toIdx != i){
			int tmp = permutation[i];
			permutation[i] = permutation[toIdx];
			permutation[toIdx] = tmp;
		}
	}
	int idx = 0;
	for( int y=0; y<MAX_ROW; y++){
		for( int x=0; x<MAX_COL; x++){
			if( idx < maxNum){
				pPuzzleData->cell[x][y] = permutation[idx++];
			}
			else{
				pPuzzleData->cell[x][y] = 0;
			}
		}
	}
}



// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MY15PUZZLE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_MY15PUZZLE));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= sizeof(LONG_PTR);
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MY15PUZZLE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_MY15PUZZLE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	PuzzleData *pPuzzleData = (PuzzleData *)GetWindowLongPtr( hWnd, 0);

	switch (message)
	{
	case WM_CREATE:
		{
		pPuzzleData = (PuzzleData *)malloc( sizeof(PuzzleData) );
		if( pPuzzleData != 0){
			ShuffleCells( pPuzzleData);
			SetWindowLongPtr( hWnd, 0, (LONG_PTR)pPuzzleData);
		}
		else{
			MessageBox( hWnd, _T("Kvmۂł܂łB"), _T("G["), MB_OK );
			return -1;
		}
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_NEW:
			ShuffleCells( pPuzzleData);
			InvalidateRect( hWnd, NULL, FALSE);
			break;
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		if( pPuzzleData != NULL){
			int mmodePrev = SetMapMode( hdc, MM_TEXT);
			int bkmodePrev = SetBkMode( hdc, TRANSPARENT);
			HPEN hpen = CreatePen( PS_SOLID, 1, RGB( 0, 0, 0) );
			HPEN hpenPrev = (HPEN)SelectObject( hdc, hpen);
			HBRUSH hbrCell = CreateSolidBrush( RGB( 192, 192, 255) );
			HBRUSH hbrPrev = (HBRUSH)SelectObject( hdc, hbrCell);
			for( int y=0; y<MAX_ROW; y++){
				for( int x=0; x<MAX_COL; x++){
					HBRUSH hbrTmp = NULL;
					if( pPuzzleData->cell[x][y] == 0){
						hbrTmp = (HBRUSH)SelectObject( hdc, hbrPrev);
					}
					
					RECT rc;
					rc.left = xOrg + x * cellWidth;
					rc.top  = yOrg + y * cellHeight;
					rc.right = rc.left + cellWidth + 1;
					rc.bottom = rc.top + cellHeight + 1;
					Rectangle( hdc, rc.left, rc.top, rc.right, rc.bottom);
					if( hbrTmp != NULL){
						SelectObject( hdc, hbrTmp);
					}
					else{
						TCHAR str[100];
						int len = _stprintf( str, _T("%d"), pPuzzleData->cell[x][y]);
						DrawText( hdc, str, -1, &rc, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
					}
				}
			}
			SelectObject( hdc, hbrPrev);
			DeleteObject( hbrCell);
			SelectObject( hdc, hpenPrev);
			DeleteObject( hpen);
			SetBkMode( hdc, bkmodePrev);
			SetMapMode( hdc, mmodePrev);

		}
		EndPaint(hWnd, &ps);
		break;
	case WM_LBUTTONUP:
		{
		int (*cell)[MAX_ROW] = pPuzzleData->cell;
		int xpos = LOWORD(lParam); 
		int ypos = HIWORD(lParam);

		int x = (xpos - xOrg)/cellWidth;
		int y = (ypos - yOrg)/cellHeight;
		if( x >= 0 && x < MAX_COL && y >= 0 && y < MAX_ROW){
			if( cell[x][y] != 0){
				if( x > 0 && cell[x-1][y] == 0){
					cell[x-1][y] = cell[x][y];
					cell[x][y] = 0;
				}
				else if( x < (MAX_COL-1) && cell[x+1][y] == 0){
					cell[x+1][y] = cell[x][y];
					cell[x][y] = 0;
				}
				else if( y > 0 && cell[x][y-1] == 0){
					cell[x][y-1] = cell[x][y];
					cell[x][y] = 0;
				}
				else if( y < (MAX_ROW-1) && cell[x][y+1] == 0){
					cell[x][y+1] = cell[x][y];
					cell[x][y] = 0;
				}
				if( cell[x][y] == 0){
					InvalidateRect( hWnd, NULL, FALSE);
					
					bool completed = true;
					int num = 1;
					for( int y=0; y<MAX_ROW; y++){
						for( int x=0; x<MAX_COL; x++){
							if( cell[x][y] != num++){
								completed = false;
								break;
							}
							if( num >= MAX_ROW * MAX_COL)	break;
						}
						if( !completed)	break;
					}
					if( completed){
						MessageBox( hWnd, _T("!!"), _T(""), MB_OK);
					}
				}
			}
		}
		}
		break;
	case WM_DESTROY:
		if( pPuzzleData != NULL)	free( pPuzzleData);
		SetWindowLongPtr( hWnd, 0, NULL);
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
