// 15Puzzle.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "15Puzzle.h"

#define MAX_LOADSTRING 100

#define DEFAULT_DIM		(4)		// ftHg̍sE
#define MAX_DIM			(7)		// T|[gő̍sE
#define MIN_DIM			(3)		// T|[gŏ̍sE
#define MAX_COL			MAX_DIM	// J
#define MAX_ROW			MAX_DIM	// s
#define MIN_CELL_SIZE	(50)	// R}̍ŏTCY
#define MARGIN			(5)		// ㉺E̗]

#define START_BUTTON_ID	(100)	// uQ[̊Jnv{^ID
#define BUTTON_WIDTH	(100)	// uQ[̊Jnv{^̕
#define BUTTON_HEIGHT	(30)	// uQ[̊Jnv{^̍

// WXg̃L[ƒl
#define MY_REGKEY		_T("Software\\NSW Special\\15Puzzle")
#define REGVAL_DIMENSION	_T("dimention")

// AvP[Ṽf[^\
struct PuzzleData{
	int cell[MAX_COL][MAX_ROW];
	int xOrg;		// xW
	int yOrg;		// yW
	int cellWidth;	// R}̕
	int cellHeight;	// R}̍
	int dim;		// ݂̍sE
};
	
// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX


// gpāCR}̏ԂVbt
static void ShuffleCells( PuzzleData *pPuzzleData)
{
	int dim = pPuzzleData->dim;
	
	// R}̖̔zɁC1珇ɐlZbg
	int permutation[MAX_COL*MAX_ROW-1];
	int maxNum = dim * dim - 1;
	for( int i=0; i<maxNum; i++){
		permutation[i] = i + 1;
	}
	
	// 擪̗vf珇ɁCʂ̗vfƃ_ɓւ
	for( int i=0; i<maxNum-1; i++){
		int toIdx = i + rand() % ( maxNum - i);
		if( toIdx != i){
			// vfقȂΓւ
			int tmp = permutation[i];
			permutation[i] = permutation[toIdx];
			permutation[toIdx] = tmp;
		}
	}
	
	// _ɕ񂾃f[^CR}2zɃRs[
	int idx = 0;
	for( int y=0; y<dim; y++){
		for( int x=0; x<dim; x++){
			if( idx < maxNum){
				pPuzzleData->cell[x][y] = permutation[idx++];
			}
			else{
				pPuzzleData->cell[x][y] = 0;
			}
		}
	}
}



// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	ConfigDlgProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;
	
	srand( GetTickCount() );

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MY15PUZZLE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_MY15PUZZLE));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= sizeof(LONG_PTR);
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MY15PUZZLE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_MY15PUZZLE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	PuzzleData *pPuzzleData = (PuzzleData *)GetWindowLongPtr( hWnd, 0);

	switch (message)
	{
	case WM_CREATE:
		{
		RECT rcClt;
		GetClientRect( hWnd, &rcClt);
		int xPos = ( rcClt.right - BUTTON_WIDTH) / 2;
		int yPos = rcClt.bottom - BUTTON_HEIGHT - MARGIN;
		HWND hwndBtn = CreateWindow( WC_BUTTON, _T("Q[Jn"),
						WS_TABSTOP| WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON,
						xPos, yPos, BUTTON_WIDTH, BUTTON_HEIGHT,
						hWnd, (HMENU)START_BUTTON_ID,
						hInst, NULL);
		int dim = DEFAULT_DIM;
		HKEY hKey;
		if( RegCreateKeyEx( HKEY_CURRENT_USER, MY_REGKEY, 0, NULL, 0,
						KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS){
			DWORD type;
			DWORD size = sizeof(dim);
			RegQueryValueEx( hKey, REGVAL_DIMENSION, 0, &type, (BYTE *)&dim, &size);
			RegCloseKey( hKey);
		}
		
		pPuzzleData = (PuzzleData *)malloc( sizeof(PuzzleData) );
		if( pPuzzleData != 0){
			pPuzzleData->dim = dim;
			ShuffleCells( pPuzzleData);
			SetWindowLongPtr( hWnd, 0, (LONG_PTR)pPuzzleData);
		
		}
		else{
			MessageBox( hWnd, _T("Kvmۂł܂łB"), _T("G["), MB_OK );
			return -1;
		}
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_NEW:
		case START_BUTTON_ID:
			ShuffleCells( pPuzzleData);
			InvalidateRect( hWnd, NULL, FALSE);
			break;
		case IDM_CONFIG:
			{
			int dim = DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_CONFIGDLG),
										hWnd, ConfigDlgProc, pPuzzleData->dim);
			if( dim > 0){
				pPuzzleData->dim = dim;
				ShuffleCells( pPuzzleData);
				InvalidateRect( hWnd, NULL, FALSE);
			}
			}
			break;
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_GETMINMAXINFO:
		{
		RECT rcWin;
		RECT rcClt;
		GetWindowRect( hWnd, &rcWin);
		GetClientRect( hWnd, &rcClt);
		MINMAXINFO *pMinMaxInfo = (MINMAXINFO *)lParam;
		int clientWidth = MIN_CELL_SIZE * 4 + MARGIN * 2 + 1;
		int clientHeight = clientWidth + BUTTON_HEIGHT + MARGIN;
		int nonClientWidth = (rcWin.right - rcWin.left) - rcClt.right;
		int nonClientHeight = (rcWin.bottom - rcWin.top) - rcClt.bottom;
		pMinMaxInfo->ptMinTrackSize.x = clientWidth + nonClientWidth;
		pMinMaxInfo->ptMinTrackSize.y = clientHeight + nonClientHeight;
		}
		break;
	case WM_SIZE:
		{
		int cltWidth = LOWORD( lParam);
		int cltHeight = HIWORD( lParam);
		int xPos = ( cltWidth - BUTTON_WIDTH) / 2;
		int yPos = cltHeight - BUTTON_HEIGHT - MARGIN;
		MoveWindow( GetDlgItem( hWnd, START_BUTTON_ID), xPos, yPos,
						BUTTON_WIDTH, BUTTON_HEIGHT, TRUE);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		if( pPuzzleData != NULL){
			int dim = pPuzzleData->dim;
			
			// ʒuƃTCY𓮓IɌvZ
			RECT rect;
			GetClientRect( hWnd, &rect);
			int cellSize = rect.right;
			if( rect.bottom - BUTTON_HEIGHT - MARGIN < rect.right){
				cellSize = rect.bottom - BUTTON_HEIGHT - MARGIN;
			}
			cellSize = ( cellSize - MARGIN*2 - 1)/dim;
			int cellHeight = cellSize;
			int cellWidth = cellSize;
			int xOrg = (rect.right - cellWidth * dim - 1)/2;
			int yOrg = (rect.bottom - cellHeight * dim - BUTTON_HEIGHT - MARGIN - 1)/2;

			int bkmodePrev = SetBkMode( hdc, TRANSPARENT);
			HPEN hpen = CreatePen( PS_SOLID, 1, RGB( 0, 0, 0) );
			HPEN hpenPrev = (HPEN)SelectObject( hdc, hpen);
			HBRUSH hbrCell = CreateSolidBrush( RGB( 192, 192, 255) );
			HBRUSH hbrPrev = (HBRUSH)SelectObject( hdc, hbrCell);
			for( int y=0; y<dim; y++){
				for( int x=0; x<dim; x++){
					HBRUSH hbrTmp = NULL;
					if( pPuzzleData->cell[x][y] == 0){
						hbrTmp = (HBRUSH)SelectObject( hdc, hbrPrev);
					}
					
					RECT rc;
					rc.left = xOrg + x * cellWidth;
					rc.top  = yOrg + y * cellHeight;
					rc.right = rc.left + cellWidth + 1;
					rc.bottom = rc.top + cellHeight + 1;
					Rectangle( hdc, rc.left, rc.top, rc.right, rc.bottom);
					if( hbrTmp != NULL){
						SelectObject( hdc, hbrTmp);
					}
					else{
						TCHAR str[100];
						int len = _stprintf( str, _T("%d"), pPuzzleData->cell[x][y]);
						DrawText( hdc, str, -1, &rc, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
					}
				}
			}
			SelectObject( hdc, hbrPrev);
			DeleteObject( hbrCell);
			SelectObject( hdc, hpenPrev);
			DeleteObject( hpen);
			SetBkMode( hdc, bkmodePrev);
			
			// f[^\̂ɕۑ
			pPuzzleData->cellWidth = cellWidth;
			pPuzzleData->cellHeight = cellHeight;
			pPuzzleData->xOrg = xOrg;
			pPuzzleData->yOrg = yOrg;
		}
		EndPaint(hWnd, &ps);
		break;
	case WM_LBUTTONUP:
		{
		int (*cell)[MAX_ROW] = pPuzzleData->cell;
		int dim = pPuzzleData->dim;
		int xpos = LOWORD(lParam); 
		int ypos = HIWORD(lParam);

		int x = (xpos - pPuzzleData->xOrg)/pPuzzleData->cellWidth;
		int y = (ypos - pPuzzleData->yOrg)/pPuzzleData->cellHeight;
		if( x >= 0 && x < dim && y >= 0 && y < MAX_ROW){
			if( cell[x][y] != 0){
				if( x > 0 && cell[x-1][y] == 0){
					cell[x-1][y] = cell[x][y];
					cell[x][y] = 0;
				}
				else if( x < (dim-1) && cell[x+1][y] == 0){
					cell[x+1][y] = cell[x][y];
					cell[x][y] = 0;
				}
				else if( y > 0 && cell[x][y-1] == 0){
					cell[x][y-1] = cell[x][y];
					cell[x][y] = 0;
				}
				else if( y < (dim-1) && cell[x][y+1] == 0){
					cell[x][y+1] = cell[x][y];
					cell[x][y] = 0;
				}
				if( cell[x][y] == 0){
					InvalidateRect( hWnd, NULL, FALSE);
					
					bool completed = true;
					int num = 1;
					for( int y=0; y<dim; y++){
						for( int x=0; x<dim; x++){
							if( cell[x][y] != num++){
								completed = false;
								break;
							}
							if( num >= dim * dim)	break;
						}
						if( !completed)	break;
					}
					if( completed){
						MessageBox( hWnd, _T("!!"), _T(""), MB_OK);
					}
				}
			}
		}
		}
		break;
	case WM_DESTROY:
		{
		if( pPuzzleData != NULL){
			HKEY hKey;
			if( RegCreateKeyEx( HKEY_CURRENT_USER, MY_REGKEY, 0, NULL, 0,
							KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS){
				RegSetValueEx( hKey, REGVAL_DIMENSION, 0, REG_DWORD,
								(BYTE *)&pPuzzleData->dim, sizeof(DWORD) );
				RegCloseKey( hKey);
			}
			free( pPuzzleData);
		}
		SetWindowLongPtr( hWnd, 0, NULL);
		PostQuitMessage(0);
		}
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK ConfigDlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		SendDlgItemMessage( hDlg,IDC_DIMSPIN, UDM_SETBUDDY, 
								(WPARAM)GetDlgItem( hDlg, IDC_DIMENSION), 0);
		SendDlgItemMessage( hDlg,IDC_DIMSPIN, UDM_SETRANGE, 0,
								(LPARAM)MAKELONG(MAX_DIM,MIN_DIM));
		SendDlgItemMessage( hDlg,IDC_DIMSPIN, UDM_SETPOS, 0,
								(LPARAM)MAKELONG(lParam,0));
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDOK:
			{
			int dim = GetDlgItemInt( hDlg, IDC_DIMENSION, NULL, FALSE);
			if( dim > MAX_DIM){
				SetDlgItemInt( hDlg, IDC_DIMENSION, MAX_DIM, FALSE);
				MessageBox( hDlg, _T("wl傫܂"), _T("G["),
								MB_OK);
			}
			else if( dim < MIN_DIM){
				SetDlgItemInt( hDlg, IDC_DIMENSION, MIN_DIM, FALSE);
				MessageBox( hDlg, _T("wl܂"), _T("G["),
								MB_OK);
			}
			else{
				EndDialog(hDlg, dim);
				return (INT_PTR)TRUE;
			}
			}
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;	
}
